Subject: 24.3.92; doc-view-open-text raises wrong-type-argument error
From: Stephen Berman <[email-masked]>
To: [email-masked]
Date: Thu, 10 Jul 2014 14:26:18 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

If I'm using Gnus to read mail with an attachment, I can type `c' on the
attachment to view it in another buffer, and if the attachment is
something that Doc View can handle, I can type `C-c C-c' in the buffer
to view the rendered image of the attachment.  But if I then type `C-c
C-t' (doc-view-open-text) to view the ascii text of the attachment, I
get this error:

Debugger entered--Lisp error: (wrong-type-argument stringp nil)
  file-name-nondirectory(nil)
  doc-view-open-text()
  call-interactively(doc-view-open-text nil nil)
  command-execute(doc-view-open-text)

The reason is that Doc View expects the buffer to be visiting a file.
But with an mail attachment, that does not have to be the case (when I
type `C-c C-c', Doc View says: "The buffer has been modified.  Save the
changes? (y or n)", but if I answer "n", it still renders the image).
The following patch lets me view the ascii text whether or not the
buffer containing the document is visiting a file.  (The patch is
against emacs-24; the error also happens in trunk.)

Steve Berman

In GNU Emacs 24.3.92.7 (x86_64-suse-linux-gnu, GTK+ Version 3.10.4)
 of 2014-07-10 on rosalinde
Repository revision: 117368 [email-masked]
Windowing system distributor `The X.Org Foundation', version 11.0.11403901
System Description:	openSUSE 13.1 (Bottle) (x86_64)

Configured using:
 `configure --without-toolkit-scroll-bars CFLAGS=-g3'

Important settings:
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: @im=ibus
  locale-coding-system: utf-8-unix

=== modified file 'lisp/doc-view.el'
*** lisp/doc-view.el	2014-04-04 17:42:55 +0000
--- lisp/doc-view.el	2014-07-10 11:54:18 +0000
***************
*** 1402,1412 ****
    (interactive)
    (if doc-view--current-converter-processes
        (message "DocView: please wait till conversion finished.")
!     (let ((txt (expand-file-name "doc.txt" (doc-view--current-cache-dir))))
        (if (file-readable-p txt)
  	  (let ((name (concat "Text contents of "
! 			      (file-name-nondirectory buffer-file-name)))
! 		(dir (file-name-directory buffer-file-name)))
  	    (with-current-buffer (find-file txt)
  	      (rename-buffer name)
  	      (setq default-directory dir)))
--- 1402,1413 ----
    (interactive)
    (if doc-view--current-converter-processes
        (message "DocView: please wait till conversion finished.")
!     (let ((txt (expand-file-name "doc.txt" (doc-view--current-cache-dir)))
! 	  (bname (or buffer-file-name (buffer-name))))
        (if (file-readable-p txt)
  	  (let ((name (concat "Text contents of "
! 			      (file-name-nondirectory bname)))
! 		(dir (or (file-name-directory bname) default-directory)))
  	    (with-current-buffer (find-file txt)
  	      (rename-buffer name)
  	      (setq default-directory dir)))